{$M 65520,0,655350}
{ naprogramoval: #40 }
uses crt;
type
PPerson = ^TPerson;
TPerson = record
          ID: string[12];
          Name: String[20];
          SName: String[20];
          Gender: char;
          Yob: Longint;         { year of birth }
          Yod: longint;         { year of death }
          Mother: string[12];
          Father: string[12];
          WrittenAsPartner: boolean;
          Marked: boolean;
{          Partners: array[0..100] of string[20];
          PartCnt: longint; }
{          procedure AddPart(AID: string);}
          end;

var
PersonCnt: longint;
Persons: array[0..10000] of PPerson;
NullPerson:PPerson;
ActPerson: PPerson;
ActID: string;

function FindIDinLoad(ad: string): longint; forward;  { nalezne osobu podle ID }
function AnalyzeElement(s:string):string;    { vytahne z retezce nazev elementu }
begin
while (s[1]<>'<') do delete(s,1,1);
AnalyzeElement:=s;
end;

function Selector(Max: longint;Gnd: char): string;      { provede vyber osoby - zavislost na pohlavi zatim neni implementovana }
var
CH:char;
Sel: longint;
begin
Sel:=0;

repeat
if (Max=0) then ch:=#27 else begin
GotoXY(1,WhereY);
clreol;
write(Persons[Sel]^.name+' '+Persons[Sel]^.sname);
ch:=readkey;

if (ch='K') and (Sel>0) then Dec(Sel);
if (ch='M') and (Sel<Max) then Inc(Sel);
end;
until (ch=#13) or (ch=#27);
if (ch=#13) then Selector:=Persons[Sel]^.Id else Selector:='';
end;

function StrToInt(S:String):Longint;    { prevede retezec na cislo }
var
Code: integer;
L:Longint;
begin
val(s,l,code);
StrToInt:=L;
end;

procedure ParseElement(var T:Text;el: string);  { projde obsah elementu a ulozi do pameti }
var
ch:char;
S:String;
begin
s:='';
if (el='<osoba>') then begin
   New(Persons[PersonCnt]);
   ActPerson:=Persons[PersonCnt];
   inc(PersonCnt);
   end;
repeat
read(t,ch);
S:=s+ch;
if (pos('<',s)<>0) and (pos('/>',s)<>0) then begin
   while (s[1]<>'<') do delete(s,1,1);
   delete(s,1,1);
   s:=copy(s,1,pos('/>',s)-1);

   if (s='jmeno') then ActPerson^.name:='';
   if (s='prijmeni') then ActPerson^.sname:='';
   if (s='narozeni') then ActPerson^.yob:=0;
   if (s='umrti') then ActPerson^.yod:=0;
   if (s='matka') then ActPerson^.mother:='';
   if (s='otec') then ActPerson^.father:='';
   s:='';
   end;
if (pos('</',s)<>0) and (pos('>',s)<>0)
    then begin
         s:=copy(s,1,pos('</',s)-1);
         if (el='<id>') then begin
            while (FindIDinLoad(s)<>-1) do s:='i'+s;
            ActPerson^.ID:=s;
            end;

         if (el='<jmeno>') then ActPerson^.name:=s;
         if (el='<prijmeni>') then ActPerson^.sname:=s;
         if (el='<narozeni>') then ActPerson^.yob:=StrToInt(s);
         if (el='<pohlavi>') then ActPerson^.Gender:=s[1];
         if (el='<umrti>') then ActPerson^.yod:=StrToInt(s);
         if (el='<matka>') then ActPerson^.mother:=s;
         if (el='<otec>') then ActPerson^.father:=s;
         exit;
         end;
if (pos('<',s)<>0) and (pos('>',s)<>0) and (pos('<',s)<pos('>',s))
   then begin
        ParseElement(T,AnalyzeElement(s));
        s:='';
        end;
until eof(t);
end;

procedure LoadXML(fname:string);                { nacte XML soubor }
var
T:Text;
ch:char;
S:String;
Active: string;
begin
PersonCnt:=0;
assign(t,fname);
reset(t);
s:='';
repeat
read(t,ch);
S:=s+ch;
if (pos('<',s)<>0) and (pos('>',s)<>0) and (pos('<',s)<pos('>',s))
   then begin
        if (AnalyzeElement(s))='<rodokmen>' then ParseElement(t,s);
        s:='';
        end;
until eof(t);
end;

procedure MergeXML(fname:string);   { slouci xml soubory }
var
T:Text;
ch:char;
S:String;
Active: string;
begin
assign(t,fname);
reset(t);
s:='';
repeat
read(t,ch);
S:=s+ch;
if (pos('<',s)<>0) and (pos('>',s)<>0) and (pos('<',s)<pos('>',s))
   then begin
        if (AnalyzeElement(s))='<rodokmen>' then ParseElement(t,s);
        s:='';
        end;
until eof(t);
end;

procedure WriteStats(index: longint);
var
E: PPerson;
begin
E:=Persons[Index];
Writeln('ID:  ',E^.ID);
writeln('Jmeno:   ',E^.Name);
Writeln('Prijmeni:',E^.SName);
Writeln('Pohlavi :',E^.Gender);
end;

var
X: longint;
E: PPerson;

function FindID(ad: string): longint;           { nalezne osobu podle ID }
var
idx: longint;
begin
for idx:=0 to PersonCnt-1 do
    if (ad = Persons[idx]^.Id) then begin
       FindID:=idx;
       exit;
       end;

Idx:=-1;
FindID:=Idx;
end;

function FindIDinLoad(ad: string): longint;     { nalezne osobu podle ID krome nacitane osoby }
var
idx: longint;
begin
for idx:=0 to PersonCnt-2 do
    if (ad = Persons[idx]^.Id) then begin
       FindIDinLoad:=idx;
       exit;
       end;

Idx:=-1;
FindIDinLoad:=Idx;
end;

procedure AddPerson;            { Vlozi osobu do pameti }
var
E: PPerson;
S:String;
begin
new(Persons[PersonCnt]);
E:=Persons[PersonCnt];
repeat
write('Zadejte ID:');
readln(s);
until FindID(s)=-1;
E^.Id:=s;
write('Zadejte jmeno:');
readln(E^.Name);
write('Zadejte prijmeni:');
readln(E^.SName);
write('Zadejte pohlavi:');
repeat
readln(E^.Gender);
E^.Gender:=Upcase(E^.Gender);
until (E^.Gender='M') or (E^.Gender='Z');
write('Zadejte rok narozeni:');
repeat
readln(E^.yob);
until ioresult=0;

write('Zadejte rok umrti:');
{$I-}
repeat
readln(E^.yod);
until ioresult=0;

writeln('Vyberte matku: (ESC=nezadany)');
{readln(E^.Mother);}
E^.mother:=Selector(PersonCnt-1,'Z');
writeln;
writeln('Vyberte otce: (ESC=nezadany)');
E^.Father:=Selector(PersonCnt-1,'M');;

inc(PersonCnt);
end;

function IsChild(ChildIDX:Longint;ParentID: string): boolean;   { Zjisti,zda je osoba primym potomkem jine osoby }
var
Child: PPerson;
begin
Child:=Persons[ChildIDX];
if (Child^.Father=ParentID) or (Child^.Mother=ParentID) then
   IsChild:=true else IsChild:=false;
end;

procedure ShowID(APId: String);
var
E,F: PPerson;
X,MIDX,FIDX: longint;
PY: byte;
begin
if (FindID(APID)=-1) then exit;
E:=Persons[FindID(APID)];
Textattr:=30;
clrscr;
Writeln('ID:              ',E^.ID);writeln;
writeln('Jmeno:           ',E^.Name);writeln;
writeln('Prijmeni:        ',E^.SName);writeln;
if (e^.Yob<>0) then
   writeln('Rok narozeni:    ',E^.Yob); writeln;
if (e^.Yod<>0) then
writeln('Rok umrti:       ',E^.Yod); writeln;
writeln('Pohlavi:         ',E^.Gender); writeln;
MIDX:=FindID(E^.Mother);
if MIDX<>-1 then begin
    writeln('Matka:           ',Persons[MIDX]^.name+' '+Persons[MIDX]^.sname); writeln; end;

FIDX:=FindID(E^.Father);
if FIDX<>-1 then begin
    writeln('Otec:            ',Persons[FIDX]^.name+' '+Persons[FIDX]^.sname); writeln; end;

Writeln('Deti:                                        ');
for x:=0 to PersonCnt-1 do Persons[x]^.WrittenAsPartner:=false;

for x:=0 to PersonCnt-1 do begin
    F:=Persons[x];
    if (IsChild(x,E^.ID)) then begin
      Writeln(F^.name+' '+F^.sname);
      if (E^.Gender='M') and (F^.Mother<>'') then
                         Persons[FindID(F^.Mother)]^.WrittenAsPartner:=true;
      if (E^.Gender='Z') and (F^.Father<>'') then
                         Persons[FindID(F^.Father)]^.WrittenAsPartner:=true;
      end;
   end;
PY:=0;
gotoxy(56,4);

if (E^.Gender='M') then writeln('Manzelky:') else writeln('Manzele:');
for x:=0 to PersonCnt-1 do begin
    F:=Persons[x];
    if F^.WrittenAsPartner then begin
       gotoxy(56,5+PY);
       writeln(F^.name+' '+F^.sname);
       inc(py);
       end;
    end;
end;

procedure SelectPartners(Who: longint);         { Zobrazi partnery }
var
E,F: PPerson;
X: Longint;
Menu: array[1..100] of string;
MenuC: longint;
Num: longint;
begin
clrscr;
writeln('       Manzelky/manzele: ');writeln;
MenuC:=0;
E:=Persons[who];
for x:=0 to PersonCnt-1 do begin
    F:=Persons[x];
    if (F^.WrittenAsPartner) then begin
       inc(MenuC);
       Menu[MenuC]:=F^.ID;
       Writeln(MenuC:4,'. '+F^.name+' '+f^.sname);
       end;
    end;

if MenuC=0 then exit;
{$i-}
repeat
Write('Zadejte cislo manzela/manzelky: '); Readln(num);
until ioresult=0;
ActID:=Menu[num];
end;

procedure SelectChildren(Who: longint); { Zobrazi prime potomky }
var
E,F: PPerson;
X: Longint;
Menu: array[1..100] of string;
MenuC: longint;
Num: longint;
begin
clrscr;
writeln('       Deti: ');writeln;
MenuC:=0;
E:=Persons[who];
for x:=0 to PersonCnt-1 do begin
    F:=Persons[x];
    if IsChild(x,E^.ID) then begin
       inc(MenuC);
       Menu[MenuC]:=F^.ID;
       Writeln(MenuC:4,'. '+F^.name+' '+f^.sname);
       end;
    end;
if MenuC=0 then exit;
{$I-}
repeat
Write('Zadejte cislo ditete: '); Readln(num);
until ioresult=0;

ActID:=Menu[num];
end;

procedure SelectGrandChildren(Who: longint);    { zobrazi vnoucata }
var
E,F: PPerson;
X,Y: Longint;
Menu: array[1..100] of string;
MenuC: longint;
Num: longint;
begin
clrscr;
writeln('       Vnoucata: ');writeln;
MenuC:=0;
E:=Persons[who];
for x:=0 to PersonCnt-1 do begin
    F:=Persons[x];
    if IsChild(x,E^.ID) then begin
       for y:=0 to personCnt-1 do begin
         if IsChild(y,F^.ID) then begin
          inc(MenuC);
          Menu[MenuC]:=Persons[y]^.ID;
          Writeln(MenuC:4,'. '+Persons[y]^.name+' '+Persons[y]^.sname);
          end;
        end;
       end;
    end;
if MenuC=0 then exit;
Write('Zadejte cislo vnoucete: '); Readln(num);
ActID:=Menu[num];
end;

procedure SelectAunts(Who: longint);            { zobrazi tety/stryce }
var
E,F,G: PPerson;
z,X,Y: Longint;
Menu: array[1..5] of string;
MenuC: longint;

FoundInMenu: boolean;
Menu2: array[1..100] of string;
MenuC2: longint;
Num: longint;
begin
clrscr;
writeln('       Tety/Strycove: ');writeln;
MenuC:=0;
E:=Persons[who];
for x:=0 to PersonCnt-1 do begin                { najde prarodice }
   E:=Persons[who];
   if (E^.Father<>'') then begin
      F:=Persons[FindID(E^.Father)];

      if (F^.Father<>'') then begin
         G:=Persons[FindID(F^.Father)];
         inc(MenuC);
         Menu[MenuC]:=G^.Id;
         end;

      if (F^.Mother<>'') then begin
         G:=Persons[FindID(E^.Mother)];
         Inc(MenuC);
         Menu[MenuC]:=F^.Id;
         end;
      end;

   if (E^.Mother<>'') then begin
      F:=Persons[FindID(E^.Mother)];

      if (F^.Father<>'') then begin
         G:=Persons[FindID(F^.Father)];
         inc(MenuC);
         Menu[MenuC]:=G^.Id;
         end;

      if (F^.Mother<>'') then begin
         G:=Persons[FindID(E^.Mother)];
         Inc(MenuC);
         Menu[MenuC]:=F^.Id;
         end;
      end;

    end;

MenuC2:=0;
for y:=1 to MenuC do
for x:=0 to PersonCnt-1 do              { a nasledne jejich deti }
  if (IsChild(x,Menu[y])) then begin
     FoundInMenu:=false;
     for z:=1 to menuc2 do if (Persons[x]^.Id=Menu2[z]) then FoundInMenu:=true;
     if not FoundInmenu and (e^.mother<>Persons[x]^.Id) and (e^.father<>Persons[x]^.Id) then begin
        Inc(Menuc2);
        menu2[Menuc2]:=Persons[x]^.Id;
        writeln(menuc2:4,'. ',Persons[x]^.name+' '+Persons[x]^.sname);
        end;
     end;
writeln;
if MenuC2=0 then exit;
Write('Zadejte cislo osoby: '); Readln(num);
ActID:=Menu2[num];
end;

procedure SelectBratranci(Who: longint);
var
E,F,G: PPerson;
z,X,Y: Longint;
Menu: array[1..5] of string;
MenuC: longint;

FoundInMenu: boolean;
Menu2: array[1..100] of string;
MenuC2: longint;

Menu3: array[1..100] of string;
MenuC3: longint;

Num: longint;
begin
clrscr;
writeln('       Bratranci/Sestrenice: ');writeln;
MenuC:=0;
E:=Persons[who];
for x:=0 to PersonCnt-1 do begin                { Najde prarodice }
   E:=Persons[who];
   if (E^.Father<>'') then begin
      F:=Persons[FindID(E^.Father)];

      if (F^.Father<>'') then begin
         G:=Persons[FindID(F^.Father)];
         inc(MenuC);
         Menu[MenuC]:=G^.Id;
         end;

      if (F^.Mother<>'') then begin
         G:=Persons[FindID(E^.Mother)];
         Inc(MenuC);
         Menu[MenuC]:=F^.Id;
         end;
      end;

   if (E^.Mother<>'') then begin
      F:=Persons[FindID(E^.Mother)];

      if (F^.Father<>'') then begin
         G:=Persons[FindID(F^.Father)];
         inc(MenuC);
         Menu[MenuC]:=G^.Id;
         end;

      if (F^.Mother<>'') then begin
         G:=Persons[FindID(E^.Mother)];
         Inc(MenuC);
         Menu[MenuC]:=F^.Id;
         end;
      end;

    end;

MenuC2:=0;
for y:=1 to MenuC do
for x:=0 to PersonCnt-1 do              { jejich deti }
  if (IsChild(x,Menu[y])) then begin
     FoundInMenu:=false;
     for z:=1 to menuc2 do if (Persons[x]^.Id=Menu2[z]) then FoundInMenu:=true;
     if not FoundInmenu and (e^.mother<>Persons[x]^.Id) and (e^.father<>Persons[x]^.Id) then begin
        Inc(Menuc2);
        menu2[Menuc2]:=Persons[x]^.Id;
        end;
     end;

MenuC3:=0;
for y:=1 to MenuC2 do begin             { a jejich deti }
    for x:=0 to Personcnt-1 do begin
        if IsChild(x,persons[FindID(Menu2[y])]^.id) then begin
            FoundInMenu:=false;
            for z:=1 to menuc3 do if (Persons[x]^.Id=Menu3[z]) then FoundInMenu:=true;
            if not FoundInmenu then begin
               Inc(Menuc3);
               menu3[Menuc3]:=Persons[x]^.Id;
               writeln(menuc3:4,'. ',Persons[x]^.name+' '+Persons[x]^.sname);
               end;
            end;
        end;
    end;
writeln;
if MenuC3=0 then exit;
Write('Zadejte cislo osoby: ');
{$I-}
repeat
Readln(num);
until IOResult=0;

ActID:=Menu3[num];
end;

procedure SelectParents(Who: longint);
var
E,F: PPerson;
X: Longint;
Menu: array[1..100] of string;
MenuC: longint;
Num: longint;
begin
clrscr;
writeln('       Rodice: ');writeln;
MenuC:=0;
E:=Persons[who];
if (E^.Father<>'') then begin   { najde rodice }
   F:=Persons[FindID(E^.Father)];
   writeln(1:4,'. '+F^.Name+' '+F^.Sname);
   Menu[1]:=F^.Id;
   inc(MenuC);
   end;

if (E^.Mother<>'') then begin
   F:=Persons[FindID(E^.Mother)];
   writeln(2:4,'. '+F^.Name+' '+F^.Sname);
   Menu[2]:=F^.Id;
   Inc(MenuC);
   end;

if MenuC=0 then exit;
Write('Zadejte cislo rodice: '); Readln(num);
ActID:=Menu[num];
end;

procedure SelectGrandParents(who: longint);     { najde prarodice }
var
E,F,G: PPerson;
X: Longint;
Menu: array[1..100] of string;
MenuC: longint;
Num: longint;
begin
clrscr;
writeln('       Prarodice: ');writeln;
MenuC:=0;
E:=Persons[who];
if (E^.Father<>'') then begin
   F:=Persons[FindID(E^.Father)];

   if (F^.Father<>'') then begin
      G:=Persons[FindID(F^.Father)];
      inc(MenuC);
      Menu[MenuC]:=G^.Id;
      writeln(MenuC:4,'. '+G^.Name+' '+G^.Sname);
      end;

   if (F^.Mother<>'') then begin
      G:=Persons[FindID(E^.Mother)];
      Inc(MenuC);
      writeln(MenuC:4,'. '+G^.Name+' '+G^.Sname);
      Menu[MenuC]:=F^.Id;
      end;
   end;

if (E^.Mother<>'') then begin
   F:=Persons[FindID(E^.Mother)];

   if (F^.Father<>'') then begin
      G:=Persons[FindID(F^.Father)];
      inc(MenuC);
      Menu[MenuC]:=G^.Id;
      writeln(MenuC:4,'. '+G^.Name+' '+G^.Sname);
      end;

   if (F^.Mother<>'') then begin
      G:=Persons[FindID(E^.Mother)];
      Inc(MenuC);
      writeln(MenuC:4,'. '+G^.Name+' '+G^.Sname);
      Menu[MenuC]:=F^.Id;
      end;
   end;

if MenuC=0 then exit;
Write('Zadejte cislo prarodice: '); Readln(num);
ActID:=Menu[num];
end;

procedure DeletePerson(who: longint);
var
A: longint;
ID: string;
E,F: PPerson;
begin
E:=Persons[who];

for a:=0 to personCnt-1 do begin
    F:=Persons[a];
    if (F^.Mother=E^.ID) then E^.Id:='';
    if (F^.Father=E^.ID) then E^.Id:='';
    end;

for a:=who+1 to personCnt-1 do Persons[a-1]:=Persons[a];
dec(personcnt);
ActID:=Persons[0]^.Id;
end;


procedure EditPerson(Who: longint);
var
E: PPerson;
S:String;
begin
E:=Persons[Who];
write('Zadejte jmeno:');
readln(E^.Name);
write('Zadejte prijmeni:');
readln(E^.SName);
write('Zadejte pohlavi:');
repeat
readln(E^.Gender);
E^.Gender:=Upcase(E^.Gender);
until (E^.Gender='M') or (E^.Gender='Z');
write('Zadejte rok narozeni:');
{$I-}
repeat
readln(E^.yob);
until Ioresult=0;

write('Zadejte rok umrti:');
repeat
readln(E^.yod);
until ioresult=0;

writeln('Vyberte matku: (ESC=zadna)');
E^.Mother:=Selector(PersonCnt-1,'Z');
writeln;
writeln('Vyberte otce:');
E^.Father:=Selector(PersonCnt-1,'M');
writeln;
end;

procedure FindBest(Who: longint);
var
X,y: Longint;
Menu: array[1..100] of string[40];
MenuC: longint;
AP,E: PPerson;
Num,Dif: longint;
begin
clrscr;
{$I-}
repeat
write('Zadejte max. vekovy rozdil: ');
readln(dif);
until ioresult=0;

AP:=Persons[Who];
for x:=0 to PersonCnt-1 do Persons[x]^.Marked:=false;
for x:=0 to PersonCnt-1 do begin
    E:=Persons[x];
    if (E^.yod<>0) or (x=who) or (e^.id=ap^.mother) or (e^.id=ap^.Father)
                    then E^.Marked:=true;
                    { je mrtvy, zvolena osoba, rodic }
    if (isChild(x,AP^.Id)) then begin
       E^.marked:=true; { potomek }
       for y:=0 to PersonCnt-1 do
           if IsChild(y,E^.Id) then Persons[y]^.Marked:=true;  { prapotomek }
       end;
    if ((e^.Mother=AP^.Mother) and (e^.Mother<>'')) or ((e^.Father=AP^.Father) and (e^.Father<>'')) then E^.Marked:=true;
                               { sourozenci }
    if (Ap^.Gender=E^.Gender) then E^.Marked:=true;
    if (AP^.Mother<>'') then
       if Persons[FindID(AP^.Mother)]^.Mother = E^.Id then E^.Marked:=true; { babicka z matciny strany }
    if (AP^.Mother<>'') then
       if Persons[FindID(AP^.Mother)]^.Father = E^.Id then E^.Marked:=true; { dedecek z matciny strany }
    if (AP^.Father<>'') then
       if Persons[FindID(AP^.Father)]^.Mother = E^.Id then E^.Marked:=true; { babicka z otcovy strany }
    if (AP^.Father<>'') then
       if Persons[FindID(AP^.Father)]^.Father = E^.Id then E^.Marked:=true; { dedecek z otcovy strany }
    if (Abs(E^.Yob-AP^.Yob)>dif) then E^.marked:=true;
    end;
MenuC:=0;
writeln;
writeln('Vhodni partneri ( prvnich 20 ):');
for x:=0 to PersonCnt-1 do if MenuC<20 then begin
    if (persons[x]^.marked = false) then begin
       inc(MenuC);
       Menu[MenuC]:=Persons[x]^.id;
       write(menuC:4,'. ',Persons[x]^.name+' '+Persons[x]^.sname);
    end;
  end;
Writeln; writeln('Zadejte osobu, ktera bude zobrazena:');

readln(num);
end;

procedure ShowBrowseMenu(Who: longint);
var
CH:Char;
E: PPerson;
begin
Who:=FindID(ActID);
E:=Persons[FindID(ActID)];
textattr:=31;
clrscr;
writeln(' MENU pro prochazeni - '+E^.name+' '+e^.sname);writeln;
writeln('a) manzele/manzelky');
writeln('b) deti');
writeln('c) rodice');
writeln('d) prarodice');
writeln('e) vnoucata');
writeln('f) bratranci/sestrenice');
writeln('g) prateta/prastryc');
writeln('h) tchyne/tchan');
writeln('i) zet/snacha');
writeln('j) svagr/svagrova');
writeln('k) teta/stryc');
writeln('v) nalezeni Vhodneho partnera');
writeln;
writeln('x) smazani osoby');
writeln('y) editace osoby');
writeln('z) zpet');
writeln;write('Vyberte, na koho chcete prejit..');
ch:=upcase(readkey);
case ch of
     'A': SelectPartners(Who);
     'B': SelectChildren(Who);
     'C': SelectParents(Who);
     'D': SelectGrandParents(Who);
     'E': SelectGrandChildren(Who);
     'F': SelectBratranci(Who);
     'K': SelectAunts(Who);
     'V': FindBest(Who);
     'X': DeletePerson(Who);
     'Y': EditPerson(Who);
     end;
end;

procedure DoBrowse;
var
X: Longint;
APID: String;
E: PPerson;
MIDX,FIDX: Longint;
ch:char;
begin
repeat
ShowID(Actid);
gotoxy(1,24);
Writeln('Stisknete ESC pro navrat do menu, jinou klavesu pro prochazeni');
ch:=upcase(readkey);
if (Ch<>#27) then ShowBrowseMenu(FindID(Apid));
until ch=#27;
end;

procedure Browse;
var
X: Longint;
APID: String;
E: PPerson;
MIDX,FIDX: Longint;
ch:char;
begin
if (PersonCnt=0) then exit;
ActID:=Persons[0]^.ID;
DoBrowse;

end;

procedure BrowseAll;
var
Top: longint;
A,Sel,XSel: longint;
E: PPerson;
Ch:char;
begin
Sel:=0;
Top:=0;
XSel:=0;

TextAttr:=31;
repeat
clrscr;
for a:=Top to Top+15 do begin
    if (a<PersonCnt) then begin
        E:=Persons[a];
        if (Sel=a) then textattr:=30 else textattr:=31;
        gotoxy(3,3+a-Top);
        writeln(E^.name+' '+E^.sname);
    end;
    end;
ch:=upcase(readkey);
case ch of
'H': if Sel>0 then begin
                   Dec(Sel);
                   if (XSel>0) then dec(XSel) else Dec(Top);
                   end;
'P': if Sel<Personcnt-1 then begin
                   Inc(Sel);
                   if (XSel<15) then inc(XSel) else inc(Top);
                   end;
end;
until (ch=#13) or (Ch=#27);
ActID:=Persons[Sel]^.ID;
DoBrowse;

end;

procedure Writeel(var T:Text; S:String;El: string);
begin
if (s<>'') then
   writeln(t,'          <',el,'>',s,'</',el,'>')
else
   writeln(t,'          <',el,'/>');
end;

procedure Writeelint(var T:Text; L:Longint;El: string);
begin
if (l<>0) then
   writeln(t,'          <',el,'>',l,'</',el,'>')
else
   writeln(t,'          <',el,'/>');
end;

procedure Save;
var
FName: string;
T:Text;
X: longint;
E: PPerson;
begin
write('Zadejte jmeno souboru: ');
readln(Fname);
assign(T,Fname);

rewrite(t);
writeln(t,'<rodokmen>');
for x:=0 to PersonCnt-1 do begin
    E:=Persons[x];
    writeln(t,'   <osoba>');
    writeel(t,e^.id,'id');
    writeel(t,e^.name,'jmeno');
    writeel(t,e^.sname,'prijmeni');
    writeel(t,e^.gender,'pohlavi');
    writeelint(t,e^.yob,'narozeni');
    writeelint(t,e^.yod,'umrti');
    writeel(t,e^.mother,'matka');
    writeel(t,e^.father,'otec');
    writeln(t,'   </osoba>');
    end;
writeln(t,'</rodokmen>');
close(t);
end;

procedure Load;
var
X: longint;
S:String;
Res: integer;
T:Text;
begin
repeat

write('Zadejte nazev souboru pro nacteni:');
readln(S);
if (s='') then exit;
{$I-}
assign(t,s);
reset(t);
Res:=IoResult;
if (Res<>0) then writeln('Chyba pri cteni souboru!!!');
until Res=0;
close(t);

Write('Nacitam....');
for x:=0 to PersonCnt-1 do Dispose(Persons[x]);
LoadXML(s);
Writeln('Hotovo');
end;

procedure Merge;
var
X: longint;
S:String;
Res: integer;
T:Text;
begin
repeat

write('Zadejte nazev souboru pro spojeni:');
readln(S);
if (s='') then exit;
{$I-}
assign(t,s);
reset(t);
Res:=IoResult;
if (Res<>0) then writeln('Chyba pri cteni souboru!!!');
until Res=0;
close(t);

Write('Spojuji....');
for x:=0 to PersonCnt-1 do Dispose(Persons[x]);
MergeXML(s);
Writeln('Hotovo');
end;

procedure MainMenu;
var
Ch:char;
begin
repeat
textattr:=31;
clrscr;
Writeln('HLAVNI MENU');
writeln;
writeln('1. Zadani osoby');
Writeln('2. Prochazeni rodokmenu');
writeln('3. Prochazeni seznamu vsech');
writeln('4. Ulozeni rodokmenu');
writeln('5. Nacteni rodokmenu');
writeln('6. Slouceni rodokmenu');
Writeln('7. Konec');
writeln; writeln;
ch:=readkey;
case ch of
  '1': Addperson;
  '2': Browse;
  '3': BrowseAll;
  '4': Save;
  '5': Load;
  '6': Merge;
  end;
until ch='7';
end;

begin
New(NullPerson);
PersonCnt:=0;
MainMenu;
end.